<?php
/*
Plugin Name: Click To Copy URL
Plugin URI: http://082net.com/
Description: Javascript + Flash trackback(or else) URL copier works with FireFox.
Version: 0.32
Author: Choen, Youngmin
Author URI: http://082net.com/
*//*
Change Logs ::


Lisense : GPL(http://www.gnu.org/copyleft/gpl.html)
/*  Copyright 2006  Cheon, Young-Min  (email : 082net@gmail.com, site : http://082net.com)
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function clicktocopy_get_jslib() {
	global $wp_version;
	if ($wp_version < '2.1')
		return false;
	if ($wp_version < '2.2')
		return 'prototype';
	else
		return 'jquery';
}

function clicktocopy_enqueue_script() {
	global $withcomments, $wp_version;
	if ( !is_single() && !is_page() && !$withcomments )
		return;
	$jslib = clicktocopy_get_jslib();
	if ($jslib)
		wp_enqueue_script($jslib);
}

function clicktocopy_footer() {
	global $withcomments;
	if ( !is_single() && !is_page() && !$withcomments )
		return;
	$jslib = clicktocopy_get_jslib();
	if (!$jslib)
		$jslib = 'none';

	$copy_alert = true;	// true or false :: Set this false for no alert window.
	$plugin_folder = dirname(plugin_basename(__FILE__));
	$this_url = get_settings('siteurl').'/wp-content/plugins/'.$plugin_folder;
	load_plugin_textdomain('clicktocopy', 'wp-content/plugins/'.$plugin_folder);
	switch ($jslib) {
		case 'none': default:
			clicktocopy_footer_none();
		break;
		case 'jquery':
			clicktocopy_footer_jquery();
		break;
		case 'prototype':
			clicktocopy_footer_prototype();
		break;
		/*case 'mootools-Base':
			clicktocopy_footer_mootools();
		break;*/
	}
?>
<script type="text/javascript">//<![CDATA[
var isMSIE = !!(window.attachEvent && !window.opera);
// javascript from filebrowser(http://thefilebrowser.com/)
function ClickToCopy(element) {
	if(typeof element == 'element' || typeof element == 'object') var el = element;
	else var el = document.getElementById(element);
	try {
		if(isMSIE) {
			window.clipboardData.setData('Text',el.href);
			window.alert("<?php _e('URL copied to clipboard', 'clicktocopy') ?>");
		} else {
			var flashcopier = 'flashcopier';

			if(!document.getElementById(flashcopier)) {
				var divholder = document.createElement('div');
				divholder.id = flashcopier;
				document.body.appendChild(divholder);
			}

			document.getElementById(flashcopier).innerHTML = '';
			var divinfo = '<embed src="<?php echo $this_url; ?>/_clipboard.swf" FlashVars="clipboard='+encodeURIComponent(el.href)+'" width="0" height="0" type="application/x-shockwave-flash"><'+'/embed>';
			document.getElementById(flashcopier).innerHTML = divinfo;
			window.alert("<?php _e('URL copied to clipboard', 'clicktocopy') ?>");
		}
	}
	catch (e) {
		window.alert("<?php _e('Your browser does not supports clipboard copier', 'clicktocopy') ?>");
	}
}
//]]></script>
<?php
}

function clicktocopy_footer_none() {
?>
<script type="text/javascript">//<![CDATA[
function init_ClickToCopy() {
	var a = document.getElementsByTagName('a');
	for(var i=0; i<a.length; i++){
		if( /clicktocopy/.exec(a[i].className) || /trackback/.exec(a[i].rel) ) {
			a[i].onclick = function() {ClickToCopy(this); return false;};
		}
	}
}
init_ClickToCopy();
//]]></script>
<?php
}

function clicktocopy_footer_jquery() {
?>
<script type="text/javascript">//<![CDATA[
jQuery(document).ready(function () {
	jQuery('a .clicktocopy').click(function() { ClickToCopy(this); return false; });
	jQuery('a[@rel=trackback]').click(function() { ClickToCopy(this); return false; });
});
//]]></script>
<?php
}

function clicktocopy_footer_prototype() {
?>
<script type="text/javascript">//<![CDATA[
window.observe('load', function() {
	$$('a .clicktocopy').invoke('observe', 'click', ClickToCopy);
	$$('a[@rel=trackback]').invoke('observe', 'click', ClickToCopy);
});
//]]></script>
<?php
}

function clicktocopy_footer_mootools() {
	// TO DO>>>
?>
<script type="text/javascript">//<![CDATA[
//]]></script>
<?php
}

add_action('wp_head', 'clicktocopy_enqueue_script');
add_action('wp_footer', 'clicktocopy_footer', 10);
?>